{..............................................................................}
{ Justification Net Label.                                                     }
{ Copyright (Constantine Dedov)                                                }
{ d110272@yandex.ru                                                            }
{..............................................................................}

{..............................................................................}
Var
  JustNetLabelForm    : TJustNetLabelForm;
  Just                : Integer;
  SchDoc              : ISch_Document;
  WorkSpace           : IWorkSpace;
  Location            : TLocation;
  //Stext             : String;
  CurrentSheet        : ISch_Document;
  //CurrentSchNetlabel: ISch_Netlabel;
  SchNetlabel         : ISch_Netlabel;
  SpatialIterator     : ISch_Iterator;
  GraphicalObj        : ISch_GraphicalObject;
  //J,J1              : String;
  //P,P1              : String;
  Rect                : TCoordRect;
{..............................................................................}

{..............................................................................}
Procedure JustNetLabel(Dummy : Integer);

Begin
    WorkSpace := GetWorkSpace;
    If WorkSpace = Nil Then Exit;

    If SchServer = Nil Then Exit;
    SchDoc := SchServer.GetCurrentSchDocument;
    If SchDoc = Nil Then Exit;

    SchNetlabel := SchServer.SchObjectFactory(eNetlabel,eCreate_GlobalCopy);
    If SchNetlabel = Nil Then Exit;

    CurrentSheet := SchServer.GetCurrentSchDocument;

    Location := TLocation;
    Rect     := TCoordRect;

    // Initialize the robots in Schematic editor.
    SchServer.ProcessControl.PreProcess(CurrentSheet, '');

    SpatialIterator := CurrentSheet.SchIterator_Create;
    If SpatialIterator = Nil Then Exit;

    If Not CurrentSheet.ChooseRectangleInteractively(Rect,
                                                     'Please select the first corner',
                                                     'Please select the second corner') Then Exit;

    // Create a spatial iterator with the boundary coordinates
    // Spatial iterator looks for Junctions and Components only.
    SpatialIterator := CurrentSheet.SchIterator_Create;
    If SpatialIterator = Nil Then Exit;
    Try
        SpatialIterator.AddFilter_Area(Rect.left, Rect.bottom, Rect.right, Rect.top);

        GraphicalObj := SpatialIterator.FirstSchObject;
        While GraphicalObj <> Nil Do
        Begin
            //If GraphicalObj.ObjectId = eDisplaySelected Then
            //Begin
            //J1 := 'X:' + IntToStr(GraphicalObj.Location.X) +
            //        ', Y:' + IntToStr(GraphicalObj.Location.Y);
            //    J  := J + J1 + #13;
            //End;

            //If GraphicalObj.Select = True Then
            Begin
            SchServer.RobotManager.SendMessage(GraphicalObj.I_ObjectAddress, c_BroadCast, SCHM_BeginModify, c_NoEventData);

               Case GraphicalObj.ObjectId Of
                  eNetLabel   : GraphicalObj.Justification := Just;
               End;
            SchServer.RobotManager.SendMessage(GraphicalObj.I_ObjectAddress, c_BroadCast, SCHM_EndModify  , c_NoEventData);

            End;

            GraphicalObj := SpatialIterator.NextSchObject;
        End;
    Finally
        CurrentSheet.SchIterator_Destroy(SpatialIterator);
    End;

    SchDoc.GraphicallyInvalidate;
End;
{..............................................................................}

{..............................................................................}
Procedure RunJustNetLabel;
//Var
//    SchNetlabel : ISch_Netlabel;
Begin

    Just := 0;
    JustNetLabelForm.ShowModal;

End;
{..............................................................................}

{..............................................................................}
procedure TJustNetLabelForm.ButtonJustNetLabelClick(Sender: TObject);
begin
     JustNetLabelForm.Visible := False;
     JustNetLabel(Just);
     close;
end;
{..............................................................................}

{..............................................................................}
// Polojenie tochki privyazki

procedure TJustNetLabelForm.RadioButton0Click(Sender: TObject);
begin
       Just := 0;
end;

procedure TJustNetLabelForm.RadioButton1Click(Sender: TObject);
begin
       Just := 1;
end;

procedure TJustNetLabelForm.RadioButton2Click(Sender: TObject);
begin
       Just := 2;
end;

procedure TJustNetLabelForm.RadioButton3Click(Sender: TObject);
begin
       Just := 3;
end;

procedure TJustNetLabelForm.RadioButton4Click(Sender: TObject);
begin
       Just := 4;
end;

procedure TJustNetLabelForm.RadioButton5Click(Sender: TObject);
begin
       Just := 5;
end;

procedure TJustNetLabelForm.RadioButton6Click(Sender: TObject);
begin
       Just := 6;
end;

procedure TJustNetLabelForm.RadioButton7Click(Sender: TObject);
begin
       Just := 7;
end;

procedure TJustNetLabelForm.RadioButton8Click(Sender: TObject);
begin
       Just := 8;
end;

End.

